---
title: 'Element: keydown event'
slug: Web/API/Element/keydown_event
tags:
  - API
  - DOM
  - Element
  - Event
  - KeyboardEvent
  - Reference
  - keyboard
  - keydown
---
<div>{{APIRef}}</div>

<p>The <strong><code>keydown</code></strong> event is fired when a key is pressed.</p>

<p>Unlike the {{Event("keypress")}} event, the <code>keydown</code> event is fired for all keys, regardless of whether they produce a character value.</p>

<table class="properties">
 <tbody>
  <tr>
   <th>Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th>Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th>Interface</th>
   <td>{{domxref("KeyboardEvent")}}</td>
  </tr>
  <tr>
   <th>Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.onkeydown", "onkeydown")}}</td>
  </tr>
 </tbody>
</table>

<p>The <code>keydown</code> and <code><a href="/en-US/docs/Web/API/Element/keyup_event">keyup</a></code> events provide a code indicating which key is pressed, while <code>keypress</code> indicates which character was entered. For example, a lowercase "a" will be reported as 65 by <code>keydown</code> and <code>keyup</code>, but as 97 by <code>keypress</code>. An uppercase "A" is reported as 65 by all events.</p>

<p>Keyboard events are only generated by <code>&lt;inputs&gt;</code>, <code>&lt;textarea&gt;</code> and anything with the <code>contentEditable</code> attribute or with <code>tabindex="-1"</code>.</p>

<p>Since Firefox 65, the <code>keydown</code> and <code><a href="/en-US/docs/Web/API/Element/keyup_event">keyup</a></code> events are now fired during IME composition, to improve cross-browser compatibility for CJKT users ({{bug(354358)}}, also see <a href="https://www.fxsitecompat.com/en-CA/docs/2018/keydown-and-keyup-events-are-now-fired-during-ime-composition/">keydown and keyup events are now fired during IME composition</a> for more useful details). To ignore all <code>keydown</code> events that are part of composition, do something like this (229 is a special value set for a <code>keyCode</code> relating to an event that has been processed by an IME):</p>

<pre class="brush: js">eventTarget.addEventListener("keydown", event =&gt; {
  if (event.isComposing || event.keyCode === 229) {
    return;
  }
  // do something
});
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="addEventListener_keydown_example">addEventListener keydown example</h3>

<p>This example logs the {{domxref("KeyboardEvent.code")}} value whenever you press down a key inside the {{HtmlElement("input")}} element.</p>

<pre class="brush: html">&lt;input placeholder="Click here, then press down a key." size="40"&gt;
&lt;p id="log"&gt;&lt;/p&gt;</pre>

<pre class="brush: js">const input = document.querySelector('input');
const log = document.getElementById('log');

input.addEventListener('keydown', logKey);

function logKey(e) {
  log.textContent += ` ${e.code}`;
}</pre>

<p>{{EmbedLiveSample("addEventListener_keydown_example")}}</p>

<h3 id="onkeydown_equivalent">onkeydown equivalent</h3>

<pre class="brush: js">input.onkeydown = logKey;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("UI Events", "#event-type-keydown")}}</td>
   <td>{{Spec2("UI Events")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.keydown_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/API/HTMLElement/input_event">input</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/Element/keypress_event">keypress</a></code></li>
 <li><code><a href="/en-US/docs/Web/API/Element/keyup_event">keyup</a></code></li>
 <li><a href="/en-US/docs/Web/API/Document/keydown_event">Document <code>keydown</code> event</a></li>
</ul>
